function ErrorBits=OurLDPCEncandDec_without_MMSE(Rate,Modulation,SNRdB)
% close all; clc ; clear
Rate=2;Modulation=4;SNRdB=2;

% Rate: 2 for 1/2, 4 for 3/4, 6 for 5/6, 8 for 7/8


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Parameters Section
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
load 802_16e_4512_d5_H H -mat;

H1=H(:,1:2256);
H2=H(:,2257:4512);
H=[H2 H1];

if Rate==2
    ParityLength=2256;
elseif Rate==4
    ParityLength=2256/3;
elseif Rate==6
    ParityLength=464;
elseif Rate==8
    ParityLength=320;
elseif Rate==10
    ParityLength=240;
end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Create Signal
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
N_sym=100;
Frame=10*N_sym;
FrameNb=100;
i_frame=1;
ErrorBits=0;
MaxErrorBits=100;

henc = fec.ldpcenc(H);
hdec=fec.ldpcdec(H);

while ((i_frame<FrameNb)&&(ErrorBits<MaxErrorBits))

TotalLocations=zeros(2256+ParityLength,Frame);
FFTsize=2^(ceil(log2((2256+ParityLength)/log2(Modulation))));     
ActiveSCs=(2256+ParityLength)/log2(Modulation);
PilotLocations=1:4:FFTsize; %pilot loc /for mod=4,16 spacing = 3. /for mod=64 spacing =4
SC_loc=setdiff(1:FFTsize,PilotLocations); SC_loc=SC_loc(1:ActiveSCs); %info location
Xp=randsrc(Frame,length(PilotLocations),[-1 1]);%Pilot generation
Pilots_PRBS=Xp.'; % PRBS patterns
x_f=zeros(FFTsize,Frame); 
x_f(PilotLocations,:)=Xp.';%insertion of the pilots 

 
InfoBits=randsrc(Frame,2256,[1 0]); % Generate 2256 information bits


tic
for k=1:Frame
    
% Encode and Modulate
CodedBits= encode(henc,InfoBits(k,:));
% Rate Matching
ParityLocations=2256+randperm(ParityLength);
TotalLocations(:,k)=[1:2256,ParityLocations]; % Should be an output of the encoder
CodedBits=CodedBits(TotalLocations(:,k));
Symbols=ModulateQAM(CodedBits,Modulation); 

%%%%Insert Data%%%%
x_f(SC_loc,k)=Symbols;
end
%%%%ifft + CP & long vector of xt%%%%%    
xt=ifft(x_f); 
xt_withCP=[xt(end-1023:end,:); xt]; 
xt_long_with_CP=reshape(xt_withCP,1,(FFTsize+1024)*Frame);

toc
%%%%%%%%%%%%%%%%%%%%%%%%Channel%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
%     Fs=10e6; %Sampling rate
%     f_m=10;  %Doppler spread
%     N_samples=length(xt_long_with_CP);
%     T=N_samples/Fs; %Sample time 
    SNR=10^(SNRdB/10);
%     
%      % Taking channel parameters from ITU table
%       TapPowerdB=[0 -9.7 -19.2 -22.8];   % in dB
%       Delay=[1 110 190 410]*1e-9; % in Sec 
% %     ChannelLength=length(TapPower);
%    
%        a_samples=[];
%        %%%%Tap power in dB to linear%%%%   
%        TapPower=10.^(TapPowerdB/10);
% %         TapPower=TapPower/norm(TapPower); % Normalize to unit channel power
% 
% 
%        F_low=f_m*10; % usaully 10*f_m the low sampling 
%                   % freq of the channel coefficients
%                   
%        N_low=ceil(T*F_low);
%        
%        %%%%Gausssian random process pass throw filter(flat/U-shaped)%%%%
%        
%        h=firpm(64,[0 2*f_m/F_low 2*f_m/F_low*1.2 1],[1 1 0 0 ]); 
%        h=h/norm(h); 
% %        channel_length=length(h);
%      for k=1:length(TapPower)
%         
%          a_low_temp=conv((randn(1,N_low+64)+1i*randn(1,N_low+64))/sqrt(2),h);%was ...,h)*TapPower(k);
%          a_low_temp=a_low_temp(65:N_low+64); % Generate first tap sampled at low freq
%          a_low(k,:)=a_low_temp;
%           channel_length=6;
%          %%%%Upsample To Fs%%%%
%          
%          a_samples(k,:)=resample(a_low(k,:),Fs,F_low);
%          Sigvar=var(a_samples(k,:)); 
%          a_samples(k,:)=a_samples(k,:)*sqrt((TapPower(k)/Sigvar));
%      end
%     %%%%Initilaize Delay Vector%%%%     
%     DelayInSamples=ceil(Delay*Fs);
%     DelayInSamples=DelayInSamples-DelayInSamples(1); 
%     
%     y=zeros(1,length(xt_long_with_CP));
%     
%     %%%%Convolution%%%%
%     for k=max(DelayInSamples)+1:length(xt_long_with_CP) 
%         for j=1:length(TapPower)
%             a(j)=xt_long_with_CP(k-DelayInSamples(j))*a_samples(j,k);
%         end
%         y(k)=sum(a);
%         
%     end 
%     
%    


% Add Noise 
SNR_corrected=SNR*(1366+2256)/FFTsize; %need to generic fit for qpsk 2256 infobits + 1366 pilots
sigma_noise=norm(xt_long_with_CP)/sqrt(length(xt_long_with_CP)*SNR_corrected); 
y=xt_long_with_CP+sigma_noise*(randn(size(xt_long_with_CP))+1i*randn(size(xt_long_with_CP)))/sqrt(2); 
channel_length=2;

yBeforeCP_RemoveMatrix=reshape(y.',FFTsize+1024,Frame);
yCP_RemoveMatrix=yBeforeCP_RemoveMatrix(1025:end,:); 
             
Y_matrix_PostFFT=fft(yCP_RemoveMatrix);
Y_Pilots=Y_matrix_PostFFT(PilotLocations,:);
EstTimeDomainChannel=ifft(Y_Pilots.*Pilots_PRBS);%Taking only pilots
EstTimeDomainChannel=EstTimeDomainChannel(1:(channel_length),:); % Kill contibutions outside the CP duration
H_est=fft(EstTimeDomainChannel,FFTsize); % est. channel
Y_equalized_withoutPilots=zeros(2256,Frame);
ppSNR=zeros(2256,Frame);
for kk=1:Frame,
%     H_est = MMSE_CE(Y_matrix_PostFFT(:,kk),Pilots_PRBS(:,kk),PilotLocations,FFTsize,4,h,SNR);
%     h_est = ifft(H_est); h_DFT = h_est(1:channel_length); 
%     H_DFT = fft(h_DFT,FFTsize);


% EstTimeDomainChannel=ifft(Y_Pilots.*Pilots_PRBS(:,kk));%Taking only pilots
% EstTimeDomainChannel=EstTimeDomainChannel(1:(channel_length)); % Kill contibutions outside the CP duration
% H_est=fft(EstTimeDomainChannel,FFTsize); % est. channel

demodulatedSCs=Y_matrix_PostFFT(:,kk)./H_est(:,kk);
Y_equalized_withoutPilots(:,kk)=demodulatedSCs(SC_loc);
ppSNR(:,kk)=abs(H_est(SC_loc)).^2/(sigma_noise^2*FFTsize);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Decode Signal
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

LLR_rate_matched=zeros(1,2*2256); 
DecodedBits_long=zeros(size(InfoBits));
for kk=1:Frame,
LLRs=SISO_LLR(Y_equalized_withoutPilots(:,kk),ppSNR(:,kk),Modulation); 
LLR_rate_matched(TotalLocations(:,kk))=LLRs; 
DecodedBits=decode(hdec, LLR_rate_matched);
DecodedBits_long(kk,:)= DecodedBits;
end
ErrorBits=biterr(DecodedBits_long ,InfoBits)+ErrorBits; % Count errors
i_frame=i_frame+1;
end





%-------------------------------------------------------

function QAM_Symbols=ModulateQAM(CodedBits,Modulation)

% QPSK mapping
MapQPSK= ([1+i 1-i -1+i -1-i])/sqrt(2);

% 16QAM mapping
Map_16QAM= ((2/sqrt(10))* ...
    [ 0.5+0.5*i 0.5+1.5*i 0.5-0.5*i 0.5-1.5*i ...
    1.5+0.5*i 1.5+1.5*i 1.5-0.5*i 1.5-1.5*i ....
    -0.5+0.5*i -0.5+1.5*i -0.5-0.5*i -0.5-1.5*i ....
    -1.5+0.5*i -1.5+1.5*i -1.5-0.5*i -1.5-1.5*i]);

% 64QAM mapping 
Map_64QAM= ((2/sqrt(42))* ...
        [ 1.5+1.5*i 1.5+0.5*i 1.5+2.5*i 1.5+3.5*i ...
            1.5-1.5*i 1.5-0.5*i 1.5-2.5*i 1.5-3.5*i   ...
            0.5+1.5*i 0.5+0.5*i 0.5+2.5*i  0.5+3.5*i  ...
            0.5-1.5*i 0.5-0.5*i 0.5-2.5*i 0.5-3.5*i   ...
            2.5+1.5*i 2.5+0.5*i 2.5+2.5*i  2.5+3.5*i  ...
            2.5-1.5*i 2.5-0.5*i 2.5-2.5*i 2.5-3.5*i   ...
            3.5+1.5*i 3.5+0.5*i 3.5+2.5*i  3.5+3.5*i  ...
            3.5-1.5*i 3.5-0.5*i 3.5-2.5*i 3.5-3.5*i   ...
            -1.5+1.5*i -1.5+0.5*i -1.5+2.5*i  -1.5+3.5*i  ...
            -1.5-1.5*i -1.5-0.5*i -1.5-2.5*i -1.5-3.5*i   ...
            -0.5+1.5*i -0.5+0.5*i -0.5+2.5*i  -0.5+3.5*i  ...
            -0.5-1.5*i -0.5-0.5*i -0.5-2.5*i -0.5-3.5*i   ...
            -2.5+1.5*i -2.5+0.5*i -2.5+2.5*i  -2.5+3.5*i  ...
            -2.5-1.5*i -2.5-0.5*i -2.5-2.5*i -2.5-3.5*i   ...
            -3.5+1.5*i -3.5+0.5*i -3.5+2.5*i  -3.5+3.5*i  ...
            -3.5-1.5*i -3.5-0.5*i -3.5-2.5*i -3.5-3.5*i]); 



if Modulation==4
    Map=MapQPSK;
elseif Modulation==16
    Map=Map_16QAM;
elseif Modulation==64
    Map=Map_64QAM;
    
end;

BitsPerCarrier=log2(Modulation);
CodedBitMat=reshape(CodedBits.',BitsPerCarrier,length(CodedBits)/BitsPerCarrier);
SymbolIndices=bi2de(fliplr(CodedBitMat.'))+1;
QAM_Symbols=Map(SymbolIndices);



